// EventSample.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "EventSample.h"

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX

#define	CAPTION_START		_T("Jn")
#define	CAPTION_WAITING		_T("ҋ@")
#define	CAPTION_SIGNAL		_T("VOi")
#define	CAPTION_NONSIGNAL	_T("VOi")
#define	NAME_EVENT			_T("NSW_EVENTSAMPLE")

struct THREADPARAM{
	HWND hDlg;		// _CAOE{bNX̃EBhEEnh
	int ctrlID;		// XbhN{^̃Rg[ID
};

HANDLE g_hEvent = NULL;

static BOOL g_bManual;		// 蓮Zbg or Zbg

// XbhEvV[W
unsigned __stdcall ThreadProc(void *param)
{
	THREADPARAM *pParam = (THREADPARAM *)param;
	if(pParam != NULL){
		// LvVuҋ@vɕύX
		SetDlgItemText(pParam->hDlg, pParam->ctrlID, CAPTION_WAITING);
		// N{^2񉟂Ȃ悤ɖ
		EnableWindow(GetDlgItem(pParam->hDlg, pParam->ctrlID), FALSE);
		
		// Cxgʒm𖳌ɑ҂
		WaitForSingleObject(g_hEvent, INFINITE);
		
		// LvV߂āCL
		SetDlgItemText(pParam->hDlg, pParam->ctrlID, CAPTION_START);
		EnableWindow(GetDlgItem(pParam->hDlg, pParam->ctrlID), TRUE);
		
		free(pParam);	// XbhŖYꂸ
	}
	return 0;
}

void StartThread(HWND hDlg, int ctrlID)
{
	THREADPARAM *pParam = (THREADPARAM *)malloc(sizeof(THREADPARAM));
	if(pParam != NULL){
		pParam->hDlg = hDlg;
		pParam->ctrlID = ctrlID;
		HANDLE hThread = (HANDLE)_beginthreadex(NULL, 0, ThreadProc, pParam, 0, NULL);
		CloseHandle(hThread);
	}
}

// 蓮Zbg̏ꍇ̂݁C_CAOɃVOiԂ\
static
void SetSignalState(HWND hDlg, BOOL bSignal)
{
	if(g_bManual){
		SetDlgItemText(hDlg, IDC_STATUS, bSignal? CAPTION_SIGNAL: CAPTION_NONSIGNAL);
	}
}

// _CAOEvV[W
INT_PTR CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_INITDIALOG:
		for(int i=IDC_BUTTON1; i<=IDC_BUTTON4; i++){
			SetDlgItemText(hDlg, i, CAPTION_START);
		}
		SetSignalState(hDlg, FALSE);
		return TRUE;
	
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return TRUE;

		// 3̃{^ŁCeCxgAPIĂяo
		case IDC_SET:
			SetEvent(g_hEvent);
			SetSignalState(hDlg, TRUE);
			return TRUE;
			
		case IDC_RESET:
			ResetEvent(g_hEvent);
			SetSignalState(hDlg, FALSE);
			return TRUE;
			
		case IDC_PULSE:
			PulseEvent(g_hEvent);
			SetSignalState(hDlg, FALSE);
			return TRUE;

		// ő4̃XbhN
		case IDC_BUTTON1:
		case IDC_BUTTON2:
		case IDC_BUTTON3:
		case IDC_BUTTON4:
			StartThread(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

// CxgEIuWFNg̑I_CAÕvV[W
INT_PTR CALLBACK DlgQueryProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:		// Zbg
			EndDialog(hDlg, 0);
			return TRUE;
			
		case IDCANCEL:	// 蓮Zbg
			EndDialog(hDlg, 1);
			return TRUE;
		}
	}
	return FALSE;
}

// GgE|Cg_tWinMainCCEEBhE̓_CAOE{bNX
// Ȃ̂ŁCbZ[WE[v͂Ȃ
int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hInstance);
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	
	// CxgEIuWFNg̑擾(_CAOoR)
	g_bManual = DialogBox(0, MAKEINTRESOURCE(IDD_DLGQUERY),
							GetDesktopWindow(), DlgQueryProc) != 0;
	
	// CxgEIuWFNg쐬B
	g_hEvent = CreateEvent(NULL, g_bManual, FALSE, NAME_EVENT);
	
	// CEEBhE(_CAO)\
	DialogBox(0, MAKEINTRESOURCE(IDD_DIALOG), 0, DlgProc);
	
	// CxgEIuWFNgN[Y
	CloseHandle(g_hEvent);
	
	return 0;
}
