// MutexSample.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <conio.h>	// _getch֐̂߂ɕKv

// ~[ebNXEIuWFNg̖O
#define	MUTEX_NAME	_T("NSW-NewWinAPI-06")

// WXg̃L[/l
#define	REG_KEYNAME	_T("Software\\NSW\\NewWinAPI\\Article06")
#define	REG_VALNAME	_T("Counter")

#define	MAX_THREAD	10		// Xbh
#define	MAX_ATTEMPT	10		// XbȟJԂ
#define	MAX_WAIT	1000	// ~bP

static HANDLE g_hMutex;		// ~[ebNX̃nh
static HKEY g_hKey;			// WXg̃nh

// WXgJE^ǂ
static
DWORD GetCounter(void)
{
	DWORD counter = 0;
	DWORD sz = sizeof(counter);
	RegQueryValueEx(g_hKey, REG_VALNAME, 0, NULL, (PBYTE)&counter, &sz);
	return counter;
}

// WXg̃JE^ɒlZbg
static
void SetCounter(DWORD count)
{
	RegSetValueEx(g_hKey, REG_VALNAME, 0, REG_DWORD,
						(PBYTE)&count, sizeof(count) );
}

// eXbhŁCpJE^MAX_ATTEMPTJEgAbv
unsigned __stdcall ThreadProc(void *param)
{
	DWORD thrdID = GetCurrentThreadId();
	srand(thrdID);	// nXbhID̒lŏ
	
	for(int i=0; i<MAX_ATTEMPT; i++){
		int timeToWait = rand() * MAX_WAIT / RAND_MAX;
		printf("XbhID=0x%08lx: %3d, ҂=%3d~b\n",
				thrdID, i+1, timeToWait);
		
		// pJE^ɃANZX邽߁C~[ebNX̏Lv
		if(WaitForSingleObject(g_hMutex, INFINITE)
				== WAIT_OBJECT_0){
			DWORD counter = GetCounter();
			// _ɃEFCgB
			Sleep(timeToWait);
			counter++;
			SetCounter(counter);
			
			ReleaseMutex(g_hMutex);	// LԂ
			
			// ̃JEgAbv܂ł̑҂Ԃ_
			timeToWait = rand() * MAX_WAIT / RAND_MAX;
			Sleep(timeToWait);
		}
		else{
			fprintf(stderr, "Thread %08lx: Unexpected error.\n", thrdID);
			break;
		}
	}
	
	return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
	// JE^vZXԂŋp邽߂ɁCWXggp
	if(RegCreateKeyEx(HKEY_CURRENT_USER, REG_KEYNAME, 0, NULL,
						0, KEY_ALL_ACCESS, NULL, &g_hKey, NULL)
			!= ERROR_SUCCESS){
		fprintf(stderr, "Cannot create/open a counter registiry.\n");
		return -1;
	}
	
	// Ot~[ebNXEIuWFNg쐬܂̓I[vB
	// L͂Ȃ
	g_hMutex = CreateMutex(NULL, FALSE, MUTEX_NAME);
	if(g_hMutex != NULL){
		if(GetLastError() != ERROR_ALREADY_EXISTS){
			// ~[ebNX쐬ꂽꍇ́CJE^
			SetCounter(0);
		}
		HANDLE hThread[MAX_THREAD];	// XbhEnh̔z
		for(int i=0; i<MAX_THREAD; i++){
			hThread[i] = (HANDLE)_beginthreadex(NULL, 0, ThreadProc,
													NULL, 0, NULL);
		}
		
		//ׂẴXbhI܂ő҂(3Ԗڂ̈TRUEɂ)
		(void)WaitForMultipleObjects(MAX_THREAD, hThread, TRUE, INFINITE);
		
		// ~[ebNXEnhN[Y
		CloseHandle(g_hMutex);
		
		printf("݂̃JE^[l: %d (Ғl%d)\n",
				GetCounter(), MAX_THREAD * MAX_ATTEMPT);
	}
	else{
		fprintf(stderr, "~[ebNX쐬/I[vł܂B\n");
	}
	
	RegCloseKey(g_hKey);
	
	//R\[Ă܂̂h܂
	fprintf(stderr, "L[Ă\n");
	_getch();
	
	return 0;
}
