#include "stdafx.h"
#include "SemSample.h"
#include "server.h"

#define COUNTDOWN_TIME		10

// ThreadProc̃p[^\
struct THREADPARAM
{
	SOCKET s;	// \PbgEnh
	int color;	// NGXg̃J[
};

// NCAg̃NGXg邽߂̃TuXbh
unsigned __stdcall ThreadProc(void *param)
{
	THREADPARAM *pParam = (THREADPARAM *)param;
	
	int ctrlID = AcquireCtrlID();
	SetCtrlColor(ctrlID, pParam->color);
	
	for(int i=COUNTDOWN_TIME; i>=0; i--){
		SetCtrlState(ctrlID, CTLSTATE_COUNTDOWN, i);
		Sleep(1000);
	}
	closesocket(pParam->s);
	
	SetCtrlState(ctrlID, CTLSTATE_EXITING, 0);
	Sleep(1000);
	
	SetCtrlColor(ctrlID, 0);
	SetCtrlState(ctrlID, CTLSTATE_IDLE, 0);
	
	ReleaseCtrlID(ctrlID);
	free(pParam);
	
	// IC1JEgԋp
	ReleaseSemaphore(g_hSem, 1, NULL);
	
	return 0;
}

// NCAg̃NGXg󂯕tCp̃XbhN
int ProcessRequest(SOCKET s)
{
	char buf[MAX_CMD_LEN];
	int len = recv(s, buf, sizeof(buf), 0);
	if(strcmp(buf, CMD_QUIT) == 0){
		return 1;
	}
	
	THREADPARAM *pParam = (THREADPARAM *)malloc(sizeof(THREADPARAM));
	if(pParam != NULL){
		pParam->s = s;
		if(strcmp(buf, CMD_GREEN) == 0){
			pParam->color = CTLCOLOR_GREEN;
		}
		else if(strcmp(buf, CMD_YELLOW) == 0){
			pParam->color = CTLCOLOR_YELLOW;
		}
		else if(strcmp(buf, CMD_RED) == 0){
			pParam->color = CTLCOLOR_RED;
		}
		else{
			pParam->color = 0;
		}
		
		// VKXbhN邽߂ɁCZ}tH̃JEgNGXg
		if(WaitForSingleObject(g_hSem, INFINITE) == WAIT_OBJECT_0){
			send(s, RET_ACK, strlen(RET_ACK), 0);
			(void)_beginthreadex(NULL, 0, ThreadProc, pParam, 0, NULL);
		}
	}
	return 0;
}

// T[o[EXbh
//     p[^͎gpȂ
unsigned __stdcall ServerThreadProc(void *param)
{
	SOCKET s;
	if((s = socket(AF_INET, SOCK_STREAM, 0)) != INVALID_SOCKET){
		struct sockaddr_in server;
		server.sin_family = AF_INET;
		server.sin_port   = htons(SERVER_PORT);
		server.sin_addr.s_addr = INADDR_ANY;
		if(bind(s, (struct sockaddr *)&server, sizeof(server)) == 0){
			if(listen(s, 5) == 0){
				while(1){
					struct sockaddr_in client;
					int namelen = sizeof(client);
					SOCKET ns;
					if((ns = accept(s, (struct sockaddr *)&client,
										&namelen))
							!= INVALID_SOCKET){
						if(ProcessRequest(ns) != 0)	break;
					}
				}
			}
		}
		shutdown(s, 1);
		closesocket(s);
	}
	return 0;
}

// T[o[EXbhN
HANDLE StartServer(void)
{
	return (HANDLE)_beginthreadex(NULL, 0, ServerThreadProc, NULL, 0, NULL);
}
